
#pragma newdecls required
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <tf2>
#include <tf2_stocks>

public Plugin myinfo = 
{

	name = "cp_orange_z7_n Map glitch fixed",
	author = "w1200441",
	description = "No more guns in blue melee area, no more teleport build in red spawn!",
	version = "1.0.0",
	url = "https://steamcommunity.com/id/w1200441/"
};

public void OnPluginStart()
{
	RegAdminCmd("sm_w12rebuild", Command_ReBuild, ADMFLAG_CHEATS, "Rebuild Entites");	
	HookEvent("teamplay_round_active", Event_RoundActive, EventHookMode_Pre);
}

public void OnMapStart()
{
	if(IsCorrectMap())
	{
		CreateTimer(2.0, HookMapEntry);
	}
}

public void Event_RoundActive(Event event, const char[] name, bool dontBroadcast)
{
	if(IsCorrectMap())
	{
		Rebuild();
	}
}

public Action Command_ReBuild(int client, int args)
{
	if(IsCorrectMap())
	{
		Rebuild();
	}
	else ReplyToCommand(client, "Command enable for map [ cp_orange_z7_n ] only.");
	
	return Plugin_Handled;
}

public void Rebuild()
{
	CreateTimer(0.0, RemoveAll);
	CreateTimer(1.0, BuildMap);
	CreateTimer(2.0, HookMapEntry);
}

Action RemoveAll(Handle timer)
{
	int entity = -1;
	while ((entity = FindEntityByClassname(entity, "func_nobuild")) != -1)
	{
		char name[128]; GetEntPropString(entity, Prop_Data, "m_iName", name, sizeof(name));
		if(StrEqual(name, "MapEntity"))
		{
			AcceptEntityInput(entity, "Kill");
		}
	}
	return Plugin_Stop;
}

Action BuildMap(Handle timer)
{
	int prop = CreateEntityByName("func_nobuild");
	if (IsValidEntity(prop))
	{
		DispatchKeyValue(prop, "targetname", "EntityMap");
		DispatchKeyValue(prop, "model", "*99");
		DispatchKeyValue(prop, "origin", "350 4867 -1650");
		DispatchKeyValue(prop, "angles", "45 90 0");
		DispatchKeyValue(prop, "DestroyBuildings", "1");
		DispatchSpawn(prop);
		ActivateEntity(prop);
	}

	return Plugin_Stop;
}

Action HookMapEntry(Handle timer)
{
	int entity = -1;
	while ((entity = FindEntityByClassname(entity, "trigger_add_tf_player_condition")) != -1)
	{
		char modelname[128]; GetEntPropString(entity, Prop_Data, "m_ModelName", modelname, sizeof(modelname));
		if (StrEqual(modelname, "*202")||StrEqual(modelname, "*238"))
		{
			HookSingleEntityOutput(entity, "OnStartTouch", OnAreaMeleeCondition);
			HookSingleEntityOutput(entity, "OnEndTouch", OnAreaMeleeCondition);
		}
	}

	entity = -1
	while ((entity = FindEntityByClassname(entity, "trigger_teleport")) != -1)
	{
		char modelname[128];
		GetEntPropString(entity, Prop_Data, "m_ModelName", modelname, sizeof(modelname));
		if(StrEqual(modelname, "*154") || StrEqual(modelname, "*166"))
		{
			HookSingleEntityOutput(entity, "OnEndTouch", OnTeleportToSpawnRoom);
		}
	}

	return Plugin_Stop;
}

public void OnAreaMeleeCondition(const char[] output, int caller, int activator, float delay)
{
	if(IsValidClient(activator) && IsValidEntity(caller))
	{
		if(!TF2_IsPlayerInCondition(activator, TFCond_RestrictToMelee)) TF2_AddCondition(activator, TFCond_RestrictToMelee, TFCondDuration_Infinite);
		SetEntPropEnt(activator, Prop_Send, "m_hActiveWeapon", GetPlayerWeaponSlot(activator, TFWeaponSlot_Melee));
	}
}

public void OnTeleportToSpawnRoom(const char[] output, int caller, int activator, float delay)
{
	if(IsValidClient(activator) && IsValidEntity(caller))
	{
		if(TF2_IsPlayerInCondition(activator, TFCond_RestrictToMelee)) TF2_RemoveCondition(activator, TFCond_RestrictToMelee);
		TF2_RegeneratePlayer(activator);
	}
}

//===============================================================================================================================================================================================================================================
stock bool IsValidClient(int client) 
{
    if (client <= 0) return false;
    if (client > MaxClients) return false;
    return IsClientInGame(client);
}

stock bool IsCorrectMap()
{
	char map[32];
	GetCurrentMap(map, sizeof(map));
	return StrEqual(map, "cp_orange_z7_n");
}